commit 6c343f9378c8dcd4b5f9d2b93a9568c736d00404
Author: Alan Modra <amodra@gmail.com>
Date:   Thu Oct 1 19:14:09 2020 +0930

    [RS6000] ICE in decompose, at rtl.h:2282
    
    during RTL pass: fwprop1
    gcc.dg/pr82596.c: In function 'test_cststring':
    gcc.dg/pr82596.c:27:1: internal compiler error: in decompose, at rtl.h:2282
    
    -m32 gcc/testsuite/gcc.dg/pr82596.c fails along with other tests after
    applying rtx_cost patches, which exposed a backend bug.
    legitimize_address when presented with the following address
            (plus (reg) (const_int 0x7ffffffff))
    attempts to rewrite it as a high/low sum.  The low part is 0xffff, or
    -1, making the high part 0x80000000.  But this is no longer canonical
    for SImode.
    
            * config/rs6000/rs6000.c (rs6000_legitimize_address): Use
            gen_int_mode for high part of address constant.
    
    (cherry picked from commit 4c69e61f4307865b95151006e480ae2022b30454)

diff --git a/gcc/config/rs6000/rs6000.c b/gcc/config/rs6000/rs6000.c
index aea362cdf6e..891c4c54e5f 100644
--- a/gcc/config/rs6000/rs6000.c
+++ b/gcc/config/rs6000/rs6000.c
@@ -8967,7 +8967,7 @@ rs6000_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
 	low_int = 0;
       high_int = INTVAL (XEXP (x, 1)) - low_int;
       sum = force_operand (gen_rtx_PLUS (Pmode, XEXP (x, 0),
-					 GEN_INT (high_int)), 0);
+					 gen_int_mode (high_int, Pmode)), 0);
       return plus_constant (Pmode, sum, low_int);
     }
   else if (GET_CODE (x) == PLUS

